/*
    Based on Neil Kolban example for IDF: https://github.com/nkolban/esp32-snippets/blob/master/cpp_utils/tests/BLE%20Tests/SampleNotify.cpp
    Ported to Arduino ESP32 by Evandro Copercini
    Adapted for MIT AI2 by Ugo Schiara  27/01/2023
*/
#include <BLEDevice.h>
#include <BLEServer.h>
#include <BLEUtils.h>
#include <BLE2902.h>
#include <stdlib.h>

BLEServer *pServer = NULL;
BLECharacteristic * pTxCharacteristic;
bool deviceConnected = false;
bool oldDeviceConnected = false;
bool CharReceived = false;

uint8_t txValue = 0;

unsigned int KeyPressed;

#define SERVICE_UUID           "6E400001-B5A3-F393-E0A9-E50E24DCCA9E" // Server service UUID
#define CHARACTERISTIC_UUID_RX "6E400002-B5A3-F393-E0A9-E50E24DCCA9E"
#define CHARACTERISTIC_UUID_TX "6E400003-B5A3-F393-E0A9-E50E24DCCA9E"


class MyServerCallbacks: public BLEServerCallbacks {
    void onConnect(BLEServer* pServer) {
      deviceConnected = true;
    };

    void onDisconnect(BLEServer* pServer) {
      deviceConnected = false;
    }
};

class MyCallbacks: public BLECharacteristicCallbacks {
    void onWrite(BLECharacteristic *pCharacteristic) {
      std:: string rxValue = pCharacteristic->getValue();
   if (rxValue.length() > 0) {
        for (int i = 0; i < (rxValue.length()-1); i++)
        {
            //  Serial.print(rxValue[i],DEC);
              KeyPressed = (KeyPressed *10) + int(rxValue[i]);
        }
      }
     CharReceived = true;
  }
};


void setup() {
  Serial.begin(115200);

  // Create the BLE Device
  BLEDevice::init("Server Service");

  // Create the BLE Server
  pServer = BLEDevice::createServer();
  pServer->setCallbacks(new MyServerCallbacks());

  // Create the BLE Service
  BLEService *pService = pServer->createService(SERVICE_UUID);

  // Create a BLE Characteristic
  pTxCharacteristic = pService->createCharacteristic(
										CHARACTERISTIC_UUID_TX,
										BLECharacteristic::PROPERTY_NOTIFY
									);
                      
  pTxCharacteristic->addDescriptor(new BLE2902());

  BLECharacteristic * pRxCharacteristic = pService->createCharacteristic(
											 CHARACTERISTIC_UUID_RX,
											BLECharacteristic::PROPERTY_WRITE
										);

  pRxCharacteristic->setCallbacks(new MyCallbacks());

  // Start the service
  pService->start();

  // Start advertising
  pServer->getAdvertising()->start();
  Serial.println("Waiting a client connection to notify...");
}

void loop() 
{

if(CharReceived)
{
        CharReceived = false;
//        Serial.println(KeyPressed);
        
        switch (KeyPressed)
        {
                case 1 : Serial.println("Pressed 1; Switch ON LED 1");
        break;
                case 2 : Serial.println("Pressed 2; Switch ON LED 2");
        break;   
                case 3 : Serial.println("Pressed 3; Switch ON LED 3");
        break; 
                case 4 : Serial.println("Pressed 4; Switch ON LED 4");
        break; 
                case 5 : Serial.println("Pressed 5; Switch ON LED 5");
        break; 
                case 6 : Serial.println("Pressed 6; Switch OFF LED 1");
        break; 
                case 7 : Serial.println("Pressed 7; Switch OFF LED 2");
        break; 
                case 8 : Serial.println("Pressed 8; Switch OFF LED 3");
        break;
                case 9 : Serial.println("Pressed 9; Switch OFF LED 4");
        break; 
                case 10 : Serial.println("Pressed 10; Switch OFF LED 5");
        break;     
        }
        KeyPressed = 0;
 }        


}
